unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dbf, db, FileUtil, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, ActnList, Buttons, StdCtrls,DbCtrls, ComCtrls, Menus, DBGrids,
  ExtDlgs, inifiles, DBExtCtrls, windows, Translations, Registry, Types,
  Clipbrd;

type

  { TForm1 }

  TForm1 = class(TForm)
    DBImage2: TDBImage;
    DBNavigator1: TDBNavigator;
    DBText1: TDBText;
    Image3: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    srcFundort: TDataSource;
    tblFundort: TDbf;
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton20Click(Sender: TObject);
    procedure SpeedButton21Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

var Zeichnen:    Boolean;
    x0,y0,x1,y1: LongInt;
{$R *.lfm}

{ TForm1 }


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then begin
     tblFundort.Edit;
     DBImage2.Picture.LoadFromFile(OpenPictureDialog1.FileName);// Karte
     tblFundort.Post;
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  SavePictureDialog1.InitialDir:='';// Karte
  if SavePictureDialog1.Execute then begin
     with tblFundort do begin
          Edit;
          DBImage2.Picture.SaveToFile(SavePictureDialog1.FileName);// Karte
     end;
  end;
  OpenPictureDialog1.InitialDir:='';
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  // Abfrage ob Clipboard richtiges Format
  If (Clipboard.HasFormat(CF_BITMAP) or Clipboard.HasFormat(CF_TIFF)) then begin
     tblFundort.Edit;
     DBImage2.Picture.Bitmap.Assign(clipboard);// Karte aus Zwischenablage
     tblFundort.Post;
  end else begin
      MessageDlg('Die Zwischenablage ist leer!',mtError,[mbOK],0);
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if QuestionDLG('LW-Steine ','Aktuelle Grafik löschen ?',mtConfirmation,[20, 'Ja', 21, 'Nein'],0)=20 then begin
     tblFundort.Edit;
     DBImage2.Picture:=nil; // Karte / Skizze
     tblFundort.Post;
  end;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  // Karte via Zwischenablage nach Image3 kopieren und anzeigen
  Image3.Picture.Assign(DBImage2.Picture);
  Memo1.visible:=true;
end;

procedure TForm1.SpeedButton20Click(Sender: TObject);  // Abbruch
begin
  Memo1.visible:=false;
  SpeedButton20.Visible:=false;
  SpeedButton21.Visible:=false;
  Image3.Picture:=nil;
end;

procedure TForm1.SpeedButton21Click(Sender: TObject);  // Speichen
begin
  Memo1.visible:=false;
  SpeedButton20.Visible:=false;
  SpeedButton21.Visible:=false;
  TblFundort.Edit;
  DBImage2.Picture.Assign(Image3.Picture);
  TblFundort.Post;
  Image3.Picture:=nil;
end;

procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Zeichnen:=True;                      //wird nur bei MouseMove benötigt, nicht in diesem Demo-Programm
  x0:=X; y0:=Y;                        //gewollten Mittelpunkt des Kreises merken
end;


procedure TForm1.Image3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Zeichnen:=False;
  with Image3.Canvas do begin
       MoveTo(x0,y0);                     // sicherheitshalber, brauchts nicht unbedingt
       Pen.Width:=5;                      // funkioniert
       Pen.Style:=psSolid;                // funkioniert
       Pen.Color:=clRed;                  // funkioniert nicht
       Brush.Style:=bsClear;              // funkioniert
       Ellipse(x0-30,y0-30,x0+30, y0+30); // wird in weiss gezeichnet, müsste aber rot sein
       Pen.Color:=clBlack;                // funkioniert nicht
       Brush.Style:=bsSolid;              // funkioniert
       Brush.Color:=clBlack;              // funkioniert nicht
       Ellipse(x0-1,y0-1,x0+1, y0+1);     // wird in weiss gezeichnet, müsste aber schwarz sein
  end;
  SpeedButton20.Visible:=true;
  SpeedButton21.Visible:=true;
end;

end.

